// Copyright (c) 2010, Object Computing, Inc.
// All rights reserved.

#ifdef _MSC_VER
# pragma once
#endif
#ifndef MIDDLEWARENEWSBRIEF_DDSUTIL_EXPORT_H
#define MIDDLEWARENEWSBRIEF_DDSUTIL_EXPORT_H

// Compile time controls for library generation.  Define with /D or #define
// To produce or use a static library: #define MIDDLEWARENEWSBRIEF_DDSUTIL_HAS_DLL=0
//   Default is to produce/use a DLL
// While building the MIDDLEWARENEWSBRIEF_DDSUTIL_ library: #define MIDDLEWARENEWSBRIEF_DDSUTIL_BUILD_DLL
//   Default is to export symbols from a pre-built MIDDLEWARENEWSBRIEF_DDSUTIL DLL
//
// Within MIDDLEWARENEWSBRIEF_DDSUTIL use the MIDDLEWARENEWSBRIEF_DDSUTIL_Export macro where a __declspec is needed.

#if defined (_WIN32)

#  if !defined (MIDDLEWARENEWSBRIEF_DDSUTIL_HAS_DLL)
#    define MIDDLEWARENEWSBRIEF_DDSUTIL_HAS_DLL 1
#  endif /* ! MIDDLEWARENEWSBRIEF_DDSUTIL_HAS_DLL */

#  if defined (MIDDLEWARENEWSBRIEF_DDSUTIL_HAS_DLL) && (MIDDLEWARENEWSBRIEF_DDSUTIL_HAS_DLL == 1)
#    if defined (MIDDLEWARENEWSBRIEF_DDSUTIL_BUILD_DLL)
#      define MiddlewareNewsBrief_DdsUtil_Export __declspec(dllexport)
#    else /* MIDDLEWARENEWSBRIEF_DDSUTIL_BUILD_DLL */
#      define MiddlewareNewsBrief_DdsUtil_Export __declspec(dllimport)
#    endif /* MIDDLEWARENEWSBRIEF_DDSUTIL_BUILD_DLL */
#  else /* MIDDLEWARENEWSBRIEF_DDSUTIL_HAS_DLL == 1 */
#    define MiddlewareNewsBrief_DdsUtil_Export
#  endif /* MIDDLEWARENEWSBRIEF_DDSUTIL_HAS_DLL == 1 */

#  else /* !_WIN32 */

#    define MiddlewareNewsBrief_DdsUtil_Export
#  endif /* _WIN32 */
#endif /* MIDDLEWARENEWSBRIEF_DDSUTIL_EXPORT_H */

